import { Notification as ApiNotification } from '@api/eves/models';
import { AppRoutes } from '@router/router.constants';


export type AppNotification = ApiNotification;

const notificationIds = [
  "USER_CREATES_ORGANIZATION",

  "ORGANIZATION_IS_APPROVED",
  "ORGANIZATION_IS_REJECTED",

  "USER_REQUESTS_ORGANIZATION_MEMBERSHIP",

  "ORGANIZATION_MEMBERSHIP_IS_APPROVED",
  "ORGANIZATION_MEMBERSHIP_IS_REJECTED",

  "ORGANIZATION_MEMBER_REQUESTS_ROLE",

  "ORGANIZATION_MEMBER_ROLE_APPROVED",
  "ORGANIZATION_MEMBER_ROLE_REJECTED",

  "ORGANIZATION_MANAGER_UPDATES_USER_ROLE",

  "MODERATOR_DEACTIVATES_ACCOUNT",
  "MANAGER_REQUESTS_ORGANIZATION_CATEGORY_CHANGE",

  "ORGANIZATION_CATEGORY_CHANGE_APPROVED",
  "ORGANIZATION_CATEGORY_CHANGE_REJECTED",
] as const;
export type NotificationIds = typeof notificationIds[number];

const MY_ORGS = AppRoutes.MY_ROUTE + '/' + AppRoutes.MY_ORGANIZATIONS_ROUTE;
const MODERATE_ORGS = AppRoutes.MODERATE_ROUTE + '/' + AppRoutes.MODERATE_ORGANIZATIONS;

export const notificationRoutes: Record<NotificationIds, string|undefined> = {
  "USER_CREATES_ORGANIZATION": MODERATE_ORGS,

  "ORGANIZATION_IS_APPROVED": MY_ORGS,
  "ORGANIZATION_IS_REJECTED": MY_ORGS,

  "USER_REQUESTS_ORGANIZATION_MEMBERSHIP": undefined,

  "ORGANIZATION_MEMBERSHIP_IS_APPROVED": undefined,
  "ORGANIZATION_MEMBERSHIP_IS_REJECTED": undefined,

  "ORGANIZATION_MEMBER_REQUESTS_ROLE": undefined,

  "ORGANIZATION_MEMBER_ROLE_APPROVED": MY_ORGS,
  "ORGANIZATION_MEMBER_ROLE_REJECTED": MY_ORGS,

  "ORGANIZATION_MANAGER_UPDATES_USER_ROLE": MY_ORGS,

  "MODERATOR_DEACTIVATES_ACCOUNT": undefined,
  "MANAGER_REQUESTS_ORGANIZATION_CATEGORY_CHANGE": MODERATE_ORGS,

  "ORGANIZATION_CATEGORY_CHANGE_APPROVED": undefined,
  "ORGANIZATION_CATEGORY_CHANGE_REJECTED": undefined,
};
